import os
import mimetypes
import morepath
from webob.exc import HTTPNotFound


class ResourcesApp(morepath.App):
    pass


class ResourcesModel(object):
    def __init__(self, absorb=None):
        self.absorb = absorb


@ResourcesApp.path(model=ResourcesModel, path="", absorb=True)
def resources_operations(absorb):
    return ResourcesModel(absorb)


@ResourcesApp.view(model=ResourcesModel)
def resources_get(model, request):
    return get_fileresource(model, request)


def get_fileresource(model, _request):
    if model.absorb is not None:
        root_path = os.path.dirname(__file__)
        web_dist_filepath = os.path.join(root_path, "web", model.absorb)
        normed_web_dist_filepath = os.path.normpath(web_dist_filepath)
        if os.path.isfile(normed_web_dist_filepath):
            mimetype, _ = mimetypes.guess_type(normed_web_dist_filepath)
            return morepath.Response(
                 content_type=mimetype,
                 body=open(normed_web_dist_filepath, "rb").read()
             )

    raise HTTPNotFound()
